--[[-- Copyright (c) 2024 Huawei Technologies Co., Ltd.
-- openUBMC is licensed under Mulan PSL v2.
-- You can use this software according to the terms and conditions of the Mulan PSL v2.
-- You may obtain a copy of Mulan PSL v2 at:
--          http://license.coscl.org.cn/MulanPSL2
-- THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
-- EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
-- MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
-- See the Mulan PSL v2 for more details.
]] --
local validate = require 'mc.validate'
local utils = require 'mc.utils'

local GetDpuOSStartupStatus = {}

---@class NetworkAdapterIpmiCmds.GetDpuOSStartupStatusReq
---@field ManufactureId integer
---@field Offset integer
---@field Length integer
local TGetDpuOSStartupStatusReq = {}
TGetDpuOSStartupStatusReq.__index = TGetDpuOSStartupStatusReq
TGetDpuOSStartupStatusReq.group = {}

local function TGetDpuOSStartupStatusReq_from_obj(obj)
    return setmetatable(obj, TGetDpuOSStartupStatusReq)
end

function TGetDpuOSStartupStatusReq.new(ManufactureId, Offset, Length)
    return TGetDpuOSStartupStatusReq_from_obj({ManufactureId = ManufactureId, Offset = Offset, Length = Length})
end
---@param obj NetworkAdapterIpmiCmds.GetDpuOSStartupStatusReq
function TGetDpuOSStartupStatusReq:init_from_obj(obj)
    self.ManufactureId = obj.ManufactureId
    self.Offset = obj.Offset
    self.Length = obj.Length
end

function TGetDpuOSStartupStatusReq:remove_error_props(errs, obj)
    utils.remove_obj_error_property(obj, errs, TGetDpuOSStartupStatusReq.group)
end

TGetDpuOSStartupStatusReq.from_obj = TGetDpuOSStartupStatusReq_from_obj

TGetDpuOSStartupStatusReq.proto_property = {'ManufactureId', 'Offset', 'Length'}

TGetDpuOSStartupStatusReq.default = {0, 0, 0}

TGetDpuOSStartupStatusReq.struct = {
    {name = 'ManufactureId', is_array = false, struct = nil}, {name = 'Offset', is_array = false, struct = nil},
    {name = 'Length', is_array = false, struct = nil}
}

function TGetDpuOSStartupStatusReq:validate(prefix, errs, need_convert)
    prefix = prefix or ''

    validate.Optional(prefix .. 'ManufactureId', self.ManufactureId, 'uint32', false, errs, need_convert)
    validate.Optional(prefix .. 'Offset', self.Offset, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'Length', self.Length, 'uint8', false, errs, need_convert)

    TGetDpuOSStartupStatusReq:remove_error_props(errs, self)
    validate.CheckUnknowProperty(self, TGetDpuOSStartupStatusReq.proto_property, errs, need_convert)
    return self
end

function TGetDpuOSStartupStatusReq:unpack(_)
    return self.ManufactureId, self.Offset, self.Length
end

GetDpuOSStartupStatus.GetDpuOSStartupStatusReq = TGetDpuOSStartupStatusReq

---@class NetworkAdapterIpmiCmds.GetDpuOSStartupStatusRsp
---@field CompletionCode integer
---@field ManufactureId integer
---@field EndOfList integer
---@field SystemStatus integer
local TGetDpuOSStartupStatusRsp = {}
TGetDpuOSStartupStatusRsp.__index = TGetDpuOSStartupStatusRsp
TGetDpuOSStartupStatusRsp.group = {}

local function TGetDpuOSStartupStatusRsp_from_obj(obj)
    return setmetatable(obj, TGetDpuOSStartupStatusRsp)
end

function TGetDpuOSStartupStatusRsp.new(CompletionCode, ManufactureId, EndOfList, SystemStatus)
    return TGetDpuOSStartupStatusRsp_from_obj({
        CompletionCode = CompletionCode,
        ManufactureId = ManufactureId,
        EndOfList = EndOfList,
        SystemStatus = SystemStatus
    })
end
---@param obj NetworkAdapterIpmiCmds.GetDpuOSStartupStatusRsp
function TGetDpuOSStartupStatusRsp:init_from_obj(obj)
    self.CompletionCode = obj.CompletionCode
    self.ManufactureId = obj.ManufactureId
    self.EndOfList = obj.EndOfList
    self.SystemStatus = obj.SystemStatus
end

function TGetDpuOSStartupStatusRsp:remove_error_props(errs, obj)
    utils.remove_obj_error_property(obj, errs, TGetDpuOSStartupStatusRsp.group)
end

TGetDpuOSStartupStatusRsp.from_obj = TGetDpuOSStartupStatusRsp_from_obj

TGetDpuOSStartupStatusRsp.proto_property = {'CompletionCode', 'ManufactureId', 'EndOfList', 'SystemStatus'}

TGetDpuOSStartupStatusRsp.default = {0, 0, 0, 0}

TGetDpuOSStartupStatusRsp.struct = {
    {name = 'CompletionCode', is_array = false, struct = nil}, {name = 'ManufactureId', is_array = false, struct = nil},
    {name = 'EndOfList', is_array = false, struct = nil}, {name = 'SystemStatus', is_array = false, struct = nil}
}

function TGetDpuOSStartupStatusRsp:validate(prefix, errs, need_convert)
    prefix = prefix or ''

    validate.Optional(prefix .. 'CompletionCode', self.CompletionCode, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'ManufactureId', self.ManufactureId, 'uint32', false, errs, need_convert)
    validate.Optional(prefix .. 'EndOfList', self.EndOfList, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'SystemStatus', self.SystemStatus, 'uint8', false, errs, need_convert)

    TGetDpuOSStartupStatusRsp:remove_error_props(errs, self)
    validate.CheckUnknowProperty(self, TGetDpuOSStartupStatusRsp.proto_property, errs, need_convert)
    return self
end

function TGetDpuOSStartupStatusRsp:unpack(_)
    return self.CompletionCode, self.ManufactureId, self.EndOfList, self.SystemStatus
end

GetDpuOSStartupStatus.GetDpuOSStartupStatusRsp = TGetDpuOSStartupStatusRsp

return GetDpuOSStartupStatus
